
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Regular LSTMs &#8212; Battery SOH  documentation</title>
    
  <link href="_static/css/theme.css" rel="stylesheet" />
  <link href="_static/css/index.c5995385ac14fb8791e8eb36b4908be2.css" rel="stylesheet" />

    
  <link rel="stylesheet"
    href="_static/vendor/fontawesome/5.13.0/css/all.min.css">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="_static/vendor/fontawesome/5.13.0/webfonts/fa-solid-900.woff2">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="_static/vendor/fontawesome/5.13.0/webfonts/fa-brands-400.woff2">

    
      

    
    <link rel="stylesheet" type="text/css" href="_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="_static/basic.css" />
    
  <link rel="preload" as="script" href="_static/js/index.1c5a1a01449ed65a7b51.js">

    <script data-url_root="./" id="documentation_options" src="_static/documentation_options.js"></script>
    <script src="_static/jquery.js"></script>
    <script src="_static/underscore.js"></script>
    <script src="_static/doctools.js"></script>
    <script async="async" src="https://cdn.jsdelivr.net/npm/mathjax@3/es5/tex-mml-chtml.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <meta name="docsearch:language" content="en" />
    
  </head>
  <body data-spy="scroll" data-target="#bd-toc-nav" data-offset="80">
    
    <div class="container-fluid" id="banner"></div>

    
    <nav class="navbar navbar-light navbar-expand-lg bg-light fixed-top bd-navbar" id="navbar-main"><div class="container-xl">

  <div id="navbar-start">
    
    

<a class="navbar-brand" href="index.html">
  <img src="_static/logo.png" class="logo" alt="logo">
</a>


    
  </div>

  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbar-collapsible" aria-controls="navbar-collapsible" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  
  <div id="navbar-collapsible" class="col-lg-9 collapse navbar-collapse">
    <div id="navbar-center" class="mr-auto">
      
      <div class="navbar-center-item">
        <ul id="navbar-main-elements" class="navbar-nav">
    <li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="sphinx/Battery%20Classes.html">
  Battery Classes
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="sphinx/Cleaning.html">
  Treatment functions
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="sphinx/Models.html">
  Models
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="sphinx/Training.html">
  Training and Simulation
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="sphinx/Report.html">
  Report related
 </a>
</li>

    
</ul>
      </div>
      
    </div>

    <div id="navbar-end">
      
      <div class="navbar-end-item">
        <ul id="navbar-icon-links" class="navbar-nav" aria-label="Icon Links">
      </ul>
      </div>
      
    </div>
  </div>
</div>
    </nav>
    

    <div class="container-xl">
      <div class="row">
          
            
            <!-- Only show if we have sidebars configured, else just a small margin  -->
            <div class="col-12 col-md-3 bd-sidebar"><form class="bd-search d-flex align-items-center" action="search.html" method="get">
  <i class="icon fas fa-search"></i>
  <input type="search" class="form-control" name="q" id="search-input" placeholder="Search the docs ..." aria-label="Search the docs ..." autocomplete="off" >
</form><nav class="bd-links" id="bd-docs-nav" aria-label="Main navigation">
  <div class="bd-toc-item active">
    
  </div>
</nav>
            </div>
            
          

          
          <div class="d-none d-xl-block col-xl-2 bd-toc">
            
              
              <div class="toc-item">
                

<nav id="bd-toc-nav">
    
</nav>
              </div>
              
              <div class="toc-item">
                
              </div>
              
            
          </div>
          

          
          
            
          
          <main class="col-12 col-md-9 col-xl-7 py-md-5 pl-md-5 pr-md-4 bd-content" role="main">
              
              <div>
                
  <div class="section" id="regular-lstms">
<h1>Regular LSTMs<a class="headerlink" href="#regular-lstms" title="Permalink to this headline">¶</a></h1>
<p>This Neural net is based on the one proposed by You et al.’s snapshot approach
(see note for full reference). It differs to the one proposed by the authors in
its different versions (a total of 5). Versions 1-3 are included in
<a class="reference internal" href="sphinx/LSTM.html#LSTM.LSTM_v1" title="LSTM.LSTM_v1"><code class="xref py py-class docutils literal notranslate"><span class="pre">LSTM.LSTM_v1</span></code></a>, whilst versions 4-5 are included in <a class="reference internal" href="sphinx/LSTM.html#LSTM.LSTM_v4" title="LSTM.LSTM_v4"><code class="xref py py-class docutils literal notranslate"><span class="pre">LSTM.LSTM_v4</span></code></a>.
Check their documentation to learn more about the different versions and how
to call them.</p>
<p>All of them, however, have the same underlying architecture, presented here:</p>
<p>The strucutre is composed of three layers:</p>
<ol class="arabic">
<li><p>An LSTM layer that takes in a sequence of <span class="math notranslate nohighlight">\(x_i\)</span> s as input.</p>
<blockquote>
<div><p>Together, they (the <span class="math notranslate nohighlight">\(x_i\)</span> s) represent one charge cycle.
Each <span class="math notranslate nohighlight">\(x_i\)</span> is composed of a number <span class="math notranslate nohighlight">\({\Delta}\)</span> of sequential
<span class="math notranslate nohighlight">\((I, V)\)</span> or <span class="math notranslate nohighlight">\((I, V, T)\)</span> points, spread out in a 1D vector.
The actual shape of the inputs is thus: <code class="docutils literal notranslate"><span class="pre">[batch_size,</span> <span class="pre">sequence_length,</span>
<span class="pre">number_of_features]</span></code>, and the outputs have shape <code class="docutils literal notranslate"><span class="pre">[batch_size,</span>
<span class="pre">sequence_length,</span> <span class="pre">hidden_dimension*number_of_LSTMs]</span></code>.</p>
<p>The number of features depends on the model’s version (check the classes
cited previously for more information) If the LSTM is a bidirectional type,
then the <code class="docutils literal notranslate"><span class="pre">number_of_LSTMs</span></code> is equal to two. Otherwise, one.</p>
</div></blockquote>
</li>
<li><p>A Pooling layer that treats the LSTM outputs in some way.</p>
<blockquote>
<div><p>Three possibilities are proposed by the authors for the pooling layer, and
are implemented here:</p>
<ol class="arabic simple">
<li><p>taking only the last output</p></li>
<li><p>taking the mean of the outputs</p></li>
<li><p>using a BiLSTM and taking the mean of the  product of the results</p></li>
</ol>
</div></blockquote>
</li>
<li><p>A linear layer that gives the final output.</p>
<blockquote>
<div><p>It’s just one linear layer so the number of inputs and outputs is set by
the LSTM’s number of hidden dimensions and its version.</p>
</div></blockquote>
</li>
</ol>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>Full reference: G. You, S. Park and D. Oh, “Diagnosis of Electric
Vehicle Batteries Using Recurrent Neural Networks,” in IEEE Transactions
on Industrial Electronics, vol. 64, no. 6, pp. 4885-4893, June 2017,
doi: 10.1109/TIE.2017.2674593.</p>
</div>
<span class="target" id="module-LSTM"></span><dl class="py class">
<dt class="sig sig-object py" id="LSTM.LSTM_v1">
<em class="property"><span class="pre">class</span> </em><span class="sig-prename descclassname"><span class="pre">LSTM.</span></span><span class="sig-name descname"><span class="pre">LSTM_v1</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">delta</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">hidden_dim</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">pooling_layer</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'bi_mean'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">drop_out</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">0</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">norm</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">version</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">lin_layers</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">lin_dropout</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">0</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#LSTM.LSTM_v1" title="Permalink to this definition">¶</a></dt>
<dd><p>LSTM type neural net for Battery SOH estimation.</p>
<p>This class is part of the “regular” LSTMs, or the “normal” <code class="docutils literal notranslate"><span class="pre">variant</span></code>.</p>
<p>Check the documentation or source code for more information about the
architecture itself.</p>
<p>This class is made for versions 1-3, for versions 4-5 check
<a class="reference internal" href="sphinx/LSTM.html#LSTM.LSTM_v4" title="LSTM.LSTM_v4"><code class="xref py py-class docutils literal notranslate"><span class="pre">LSTM.LSTM_v4</span></code></a>.</p>
<p>Version 1 takes <span class="math notranslate nohighlight">\({\Delta}\)</span> current points and the correponding
<span class="math notranslate nohighlight">\({\Delta}\)</span> voltage points per <span class="math notranslate nohighlight">\(x_i\)</span>. Its number of features is
thus <span class="math notranslate nohighlight">\(2{\Delta}\)</span>.</p>
<p>Version 2 takes <span class="math notranslate nohighlight">\({\Delta}\)</span> current points, <span class="math notranslate nohighlight">\({\Delta}\)</span> voltage
points and <span class="math notranslate nohighlight">\({\Delta}\)</span> temperature points per <span class="math notranslate nohighlight">\(x_i\)</span>.
The temperature points are temperature measurements done during battery
cycling and may not be available for all datasets.
Its number of features is thus <span class="math notranslate nohighlight">\(3{\Delta}\)</span>.</p>
<p>Version 3 takes <span class="math notranslate nohighlight">\({\Delta}\)</span> current points, <span class="math notranslate nohighlight">\({\Delta}\)</span> voltage
points and the ambient temperature per <span class="math notranslate nohighlight">\(x_i\)</span>.
Its number of features is thus <span class="math notranslate nohighlight">\(2{\Delta}+1\)</span>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>delta</strong> (<em>int</em>) – The size of the sliding window used to generate the x_i’s.</p></li>
<li><p><strong>hidden_dim</strong> (<em>int</em>) – Hidden dimension of the LSTM (also its main output dimension).</p></li>
<li><p><strong>pooling_layer</strong> (<em>{'last'</em><em>, </em><em>'mean'</em><em>, </em><em>'bi_mean&quot;}</em>) – Decides the type of pooling layer:
- ‘last’ (only take the last result),
- ‘mean’ (take the mean of the results) and
- ‘bi_mean’ (take the mean of the product).</p></li>
<li><p><strong>drop_out</strong> (<em>float</em>) – The probability of the dropout layer that comes right after the LSTM.
Must be a number between 0 and 1.</p></li>
<li><p><strong>norm</strong> (<em>tuple</em><em>(</em><em>Tensor</em><em>, </em><em>Tensor</em><em>, </em><em>Tensor</em><em>, </em><em>Tensor</em><em>, </em><em>string</em><em>)</em><em>, </em><em>optional</em>) – <p>A tuple containing all of the information necessary for normalization.</p>
<p>This isn’t a necessary parameter and is not used in the model in any
way. It’s just useful for documentation purposes and for normalizing
test and validation sets.</p>
</p></li>
<li><p><strong>version</strong> (<em>int</em><em>, </em><em>default = 1</em>) – The model version to be used.
<code class="docutils literal notranslate"><span class="pre">version</span></code> = 1 corresponds to the model created by the article cited.
<code class="docutils literal notranslate"><span class="pre">version</span></code> = 2 corresponds to the same model, but adapted to also take
the charge cycle’s temperature data.
<code class="docutils literal notranslate"><span class="pre">version</span></code> = 3 is similar to version 1, but takes the ambient temperature
as an extra inputs.</p></li>
<li><p><strong>lin_layers</strong> (<em>int</em><em>, </em><em>default = 1</em>) – The number of linear regression layers. As of now, cannot be greater
than two.</p></li>
<li><p><strong>lin_dropout</strong> (<em>float</em><em>, </em><em>optional</em>) – The value for the dropout layer that comes after the first linear layer
in the regression step. Will only be added if <code class="docutils literal notranslate"><span class="pre">lin_layers</span></code> &gt; 1.</p></li>
</ul>
</dd>
<dt class="field-even">Raises</dt>
<dd class="field-even"><p><strong>AssertionError</strong> – If the version in different than 1, 2 or 3.
    If an unsupported pooling_layer is informed.</p>
</dd>
</dl>
<p class="rubric">Examples</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">from</span> <span class="nn">torch.utils.data</span> <span class="kn">import</span> <span class="n">Dataset</span>
<span class="gp">&gt;&gt;&gt; </span><span class="kn">from</span> <span class="nn">LSTM</span> <span class="kn">import</span> <span class="o">*</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">delta</span> <span class="o">=</span> <span class="mi">10</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">hidden_dim</span> <span class="o">=</span> <span class="mi">20</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">version</span> <span class="o">=</span> <span class="mi">2</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">model</span> <span class="o">=</span> <span class="n">LSTM_v1</span><span class="p">(</span><span class="n">delta</span><span class="p">,</span> <span class="n">hidden_dim</span><span class="p">,</span> <span class="n">pooling_layer</span><span class="o">=</span><span class="s1">&#39;last&#39;</span><span class="p">,</span> <span class="n">version</span><span class="o">=</span><span class="n">version</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="s1">&#39;B0005.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
<span class="gp">... </span>    <span class="n">Battery</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
<span class="gp">...</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">train_dataset</span> <span class="o">=</span> <span class="n">Torch_Dataset_LSTM</span><span class="p">([</span><span class="n">Battery</span><span class="p">],</span> <span class="n">delta</span><span class="p">,</span> <span class="n">version</span><span class="p">,</span> <span class="n">fixed_len</span><span class="o">=</span><span class="mi">150</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">estimated_capacity</span> <span class="o">=</span> <span class="n">model</span><span class="p">(</span><span class="n">train_dataset</span><span class="o">.</span><span class="n">inputs</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">loss_function</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">nn</span><span class="o">.</span><span class="n">MSELoss</span><span class="p">()</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">loss</span> <span class="o">=</span> <span class="n">loss_function</span><span class="p">(</span><span class="n">estimated_capacity</span><span class="p">,</span> <span class="n">train_dataset</span><span class="o">.</span><span class="n">output</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>
<span class="go">2.2862</span>
</pre></div>
</div>
<dl class="py method">
<dt class="sig sig-object py" id="LSTM.LSTM_v1.forward">
<span class="sig-name descname"><span class="pre">forward</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">inputs</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#LSTM.LSTM_v1.forward" title="Permalink to this definition">¶</a></dt>
<dd><p>Defines the computation performed at every call.</p>
<p>Should be overridden by all subclasses.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>Although the recipe for forward pass needs to be defined within
this function, one should call the <code class="xref py py-class docutils literal notranslate"><span class="pre">Module</span></code> instance afterwards
instead of this since the former takes care of running the
registered hooks while the latter silently ignores them.</p>
</div>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="LSTM.LSTM_v1.report">
<span class="sig-name descname"><span class="pre">report</span></span><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#LSTM.LSTM_v1.report" title="Permalink to this definition">¶</a></dt>
<dd><p>Creates a little report with all of the information about the class.</p>
<dl class="field-list simple">
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p></p>
</dd>
<dt class="field-even">Return type</dt>
<dd class="field-even"><p>A string with the report information.</p>
</dd>
</dl>
</dd></dl>

</dd></dl>

<dl class="py class">
<dt class="sig sig-object py" id="LSTM.LSTM_v2">
<em class="property"><span class="pre">class</span> </em><span class="sig-prename descclassname"><span class="pre">LSTM.</span></span><span class="sig-name descname"><span class="pre">LSTM_v2</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">delta</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">hidden_dim</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">pooling_layer</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'bi_mean'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">drop_out</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">0</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">norm</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#LSTM.LSTM_v2" title="Permalink to this definition">¶</a></dt>
<dd><p>LSTM type neural net for Battery SOH estimation.</p>
<div class="deprecated">
<p><span class="versionmodified deprecated">Deprecated since version 07.06.2021: </span>All of this class’s functionalities have been integrated into the
LSTM_v1 class. In order to use it, specify <code class="docutils literal notranslate"><span class="pre">version</span> <span class="pre">=</span> <span class="pre">2</span></code> upon
initialization.
This class hasn’t been removed because old reports with good results
have used it.
To find a thorough description of this class, check the
<a class="reference internal" href="sphinx/LSTM.html#LSTM.LSTM_v1" title="LSTM.LSTM_v1"><code class="xref py py-class docutils literal notranslate"><span class="pre">LSTM.LSTM_v1</span></code></a>’s docstring, as it is the same.</p>
</div>
<dl class="py method">
<dt class="sig sig-object py" id="LSTM.LSTM_v2.forward">
<span class="sig-name descname"><span class="pre">forward</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">inputs</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#LSTM.LSTM_v2.forward" title="Permalink to this definition">¶</a></dt>
<dd><p>Defines the computation performed at every call.</p>
<p>Should be overridden by all subclasses.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>Although the recipe for forward pass needs to be defined within
this function, one should call the <code class="xref py py-class docutils literal notranslate"><span class="pre">Module</span></code> instance afterwards
instead of this since the former takes care of running the
registered hooks while the latter silently ignores them.</p>
</div>
</dd></dl>

</dd></dl>

<dl class="py class">
<dt class="sig sig-object py" id="LSTM.LSTM_v4">
<em class="property"><span class="pre">class</span> </em><span class="sig-prename descclassname"><span class="pre">LSTM.</span></span><span class="sig-name descname"><span class="pre">LSTM_v4</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">delta</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">hidden_dim</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">pooling_layer</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'bi_mean'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">drop_out</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">0</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">norm</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">version</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">4</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">lin_layers</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">lin_dropout</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">0</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#LSTM.LSTM_v4" title="Permalink to this definition">¶</a></dt>
<dd><p>LSTM type neural net for Battery SOH estimation.</p>
<p>This Neural net is based on the one proposed by You et al.’s snapshot
approach (see note for full reference).</p>
<p>This Neural network is analogous to LSTM_v1, except that it takes ambient
temperature data as an input in the final regression layer.</p>
<dl>
<dt>The architecture is composed of three layers:</dt><dd><ul class="simple">
<li><p>An LSTM layer that takes in a sequence of x_i’s as input.</p></li>
</ul>
<p>Together, they represent one charge cycle. Each x_i is composed of a
number delta of (I, V) or (I, V, T) points, spread out in a 1D vector.
The actual shape of the inputs is thus:
<code class="docutils literal notranslate"><span class="pre">[batch</span> <span class="pre">size,</span> <span class="pre">sequence</span> <span class="pre">length,</span> <span class="pre">nb_features]</span></code>, and the outputs have
shape
<code class="docutils literal notranslate"><span class="pre">[batch</span> <span class="pre">size,</span> <span class="pre">sequence</span> <span class="pre">length,</span> <span class="pre">hidden</span> <span class="pre">dimension*number</span> <span class="pre">of</span> <span class="pre">LSTMs]</span></code>.
The number of features depend on the model version. It’s 2*delta for
version 4, 3*delta for version 5.</p>
<p>If the LSTM is a bidirectional type, then the number of LSTMs is
equal to two. Otherwise, one.</p>
<ul class="simple">
<li><p>A Pooling layer that treats the LSTM outputs in some way.</p></li>
</ul>
<p>Three possibilities are proposed by the authors
and are implemented here:</p>
<blockquote>
<div><ul class="simple">
<li><p>taking only the last output</p></li>
<li><p>taking the mean of the outputs</p></li>
<li><p>using a BiLSTM and taking the mean of the  product of the results</p></li>
</ul>
</div></blockquote>
<p>In order to pick the type of pooling, the variable <code class="docutils literal notranslate"><span class="pre">pooling_layer</span></code> is
used.</p>
<ul class="simple">
<li><p>A linear layer that gives the final output.</p></li>
</ul>
<p>It’s just one linear layer so the number of inputs and outputs is set by
the LSTM’s number of hidden dimensions and the size of the output
(1, it’s just the capacity).</p>
</dd>
</dl>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>Full reference: G. You, S. Park and D. Oh, “Diagnosis of Electric
Vehicle Batteries Using Recurrent Neural Networks,” in IEEE Transactions
on Industrial Electronics, vol. 64, no. 6, pp. 4885-4893, June 2017,
doi: 10.1109/TIE.2017.2674593.</p>
</div>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>delta</strong> (<em>int</em>) – The size of the sliding window used to generate the x_i’s.</p></li>
<li><p><strong>hidden_dim</strong> (<em>int</em>) – Hidden dimension of the LSTM (also its main output dimension).</p></li>
<li><p><strong>pooling_layer</strong> (<em>{'last'</em><em>, </em><em>'mean'</em><em>, </em><em>'bi_mean&quot;}</em>) – Decides the type of pooling layer:
- ‘last’ (only take the last result),
- ‘mean’ (take the mean of the results) and
- ‘bi_mean’ (take the mean of the product).</p></li>
<li><p><strong>drop_out</strong> (<em>float</em>) – The probability of the dropout layer that comes right after the LSTM.
Must be a number between 0 and 1.</p></li>
<li><p><strong>norm</strong> (<em>tuple</em><em>(</em><em>Tensor</em><em>, </em><em>Tensor</em><em>, </em><em>Tensor</em><em>, </em><em>Tensor</em><em>, </em><em>string</em><em>)</em><em>, </em><em>optional</em>) – <p>A tuple containing all of the information necessary for normalization.</p>
<p>This isn’t a necessary parameter and is not used in the model in any
way. It’s just useful for documentation purposes and for normalizing
test and validation sets.</p>
</p></li>
<li><p><strong>version</strong> (<em>int</em><em>, </em><em>default = 4</em>) – This is a new version being tested It will take the ambient temperature
as an input directly into the linear layers.
<code class="docutils literal notranslate"><span class="pre">version</span></code> = 4 corresponds to <code class="docutils literal notranslate"><span class="pre">LSTM_v1``s</span> <span class="pre">version</span> <span class="pre">1,</span> <span class="pre">and</span>
<span class="pre">``version</span></code> = 5 corresponds to <a href="#id1"><span class="problematic" id="id2">``</span></a>LSTM_v1``s version 2.</p></li>
<li><p><strong>lin_layers</strong> (<em>int</em><em>, </em><em>default = 1</em>) – The number of linear regression layers. As of now, cannot be greater
than two.</p></li>
<li><p><strong>lin_dropout</strong> (<em>float</em><em>, </em><em>optional</em>) – The value for the dropout layer that comes after the first linear layer
in the regression step. Will only be added if <code class="docutils literal notranslate"><span class="pre">lin_layers</span></code> &gt; 1.</p></li>
</ul>
</dd>
<dt class="field-even">Raises</dt>
<dd class="field-even"><p><strong>AssertionError</strong> – If the version in different than 4 or 5.
    If an unsupported pooling_layer is informed.</p>
</dd>
</dl>
<p class="rubric">Examples</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">from</span> <span class="nn">torch.utils.data</span> <span class="kn">import</span> <span class="n">Dataset</span>
<span class="gp">&gt;&gt;&gt; </span><span class="kn">from</span> <span class="nn">LSTM</span> <span class="kn">import</span> <span class="o">*</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">delta</span> <span class="o">=</span> <span class="mi">10</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">hidden_dim</span> <span class="o">=</span> <span class="mi">20</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">version</span> <span class="o">=</span> <span class="mi">4</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">model</span> <span class="o">=</span> <span class="n">LSTM_v4</span><span class="p">(</span><span class="n">delta</span><span class="p">,</span> <span class="n">hidden_dim</span><span class="p">,</span> <span class="n">pooling_layer</span><span class="o">=</span><span class="s1">&#39;last&#39;</span><span class="p">,</span> <span class="n">version</span><span class="o">=</span><span class="n">version</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="s1">&#39;B0005.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
<span class="gp">... </span>    <span class="n">Battery</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
<span class="gp">...</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">train_dataset</span> <span class="o">=</span> <span class="n">Torch_Dataset_LSTM</span><span class="p">([</span><span class="n">Battery</span><span class="p">],</span> <span class="n">delta</span><span class="p">,</span> <span class="n">version</span><span class="p">,</span> <span class="n">fixed_len</span><span class="o">=</span><span class="mi">150</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">estimated_capacity</span> <span class="o">=</span> <span class="n">model</span><span class="p">(</span><span class="n">train_dataset</span><span class="o">.</span><span class="n">inputs</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">loss_function</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">nn</span><span class="o">.</span><span class="n">MSELoss</span><span class="p">()</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">loss</span> <span class="o">=</span> <span class="n">loss_function</span><span class="p">(</span><span class="n">estimated_capacity</span><span class="p">,</span> <span class="n">train_dataset</span><span class="o">.</span><span class="n">output</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>
<span class="go">2.2862</span>
</pre></div>
</div>
<dl class="py method">
<dt class="sig sig-object py" id="LSTM.LSTM_v4.forward">
<span class="sig-name descname"><span class="pre">forward</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">inputs</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#LSTM.LSTM_v4.forward" title="Permalink to this definition">¶</a></dt>
<dd><p>Defines the computation performed at every call.</p>
<p>Should be overridden by all subclasses.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>Although the recipe for forward pass needs to be defined within
this function, one should call the <code class="xref py py-class docutils literal notranslate"><span class="pre">Module</span></code> instance afterwards
instead of this since the former takes care of running the
registered hooks while the latter silently ignores them.</p>
</div>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="LSTM.LSTM_v4.report">
<span class="sig-name descname"><span class="pre">report</span></span><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#LSTM.LSTM_v4.report" title="Permalink to this definition">¶</a></dt>
<dd><p>Creates a little report with all of the information about the class.</p>
<dl class="field-list simple">
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p></p>
</dd>
<dt class="field-even">Return type</dt>
<dd class="field-even"><p>A string with the report information.</p>
</dd>
</dl>
</dd></dl>

</dd></dl>

<dl class="py class">
<dt class="sig sig-object py" id="LSTM.Torch_Dataset_LSTM">
<em class="property"><span class="pre">class</span> </em><span class="sig-prename descclassname"><span class="pre">LSTM.</span></span><span class="sig-name descname"><span class="pre">Torch_Dataset_LSTM</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">Battery_list</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">delta</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">model_version</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">print_bool</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">False</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">time_step</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">threshold</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">0.1</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">min_len</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">150</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">fixed_len</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">150</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">norm_type</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'zscore'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">norm</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">adimensionalize</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">True</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">cycle_lim</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1000000.0</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#LSTM.Torch_Dataset_LSTM" title="Permalink to this definition">¶</a></dt>
<dd><p>Creates a pytorch Dataset class that can readily be loaded with torch’s
Loader class for training and validation.</p>
<p>The datasets created by this class’ initialization follow You et al.’s †
snapshot approach, where I, V data for a charge cycle are used for battery
capacity prediction. A number ∆ (delta) of sequential (I, V) points are
collected and turned into a 1D vector x_i. This window of points slides
through time and each vector x_i becomes the sequential inputs of an LSTM.
Here, these x_i vectors are already grouped in order in a XT 2D tensor and
stored into the list ‘ent’. One XT tensor = One charge cycle = One sequence.
The list is later saved as attribute ‘inputs’ (self.inputs = ent).</p>
<p>The output for each XT (each charge cycle) is a capacity value (in A.h).
However, capacity values are only measured during discharge cycles. Because
of this, the capacity values taken as outputs are picked from the discharge
cycle that comes immediately before the charge cycle.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>† Full reference: G. You, S. Park and D. Oh, “Diagnosis of Electric
Vehicle Batteries Using Recurrent Neural Networks,” in IEEE Transactions
on Industrial Electronics, vol. 64, no. 6, pp. 4885-4893, June 2017,
doi: 10.1109/TIE.2017.2674593.</p>
</div>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>Battery_list</strong> (<em>list</em><em>[</em><a class="reference internal" href="sphinx/NASA.html#Nasa_Classes.Clean_Battery" title="Nasa_Classes.Clean_Battery"><em>Clean_Battery</em></a><em>]</em>) – List with the Batteries that we want to use for creating the dataset.</p></li>
<li><p><strong>delta</strong> (<em>int</em>) – The size of the sliding window used to generate the x_i’s.</p></li>
<li><p><strong>model_version</strong> (<em>{1</em><em>, </em><em>2</em><em>, </em><em>3</em><em>, </em><em>4</em><em>, </em><em>5}</em>) – An integer indicating which LSTM version to use.
if <code class="docutils literal notranslate"><span class="pre">version</span></code> == 1: then only I and V data will be used.
elif <code class="docutils literal notranslate"><span class="pre">version</span></code> == 2: then I, V and T will be taken into account.
elif <code class="docutils literal notranslate"><span class="pre">version</span></code> == 3: then I, V and amb_T will be taken into account.
elif <code class="docutils literal notranslate"><span class="pre">version</span></code> == 4: then I, V and amb_T will be taken into account,
but amb_T will enter directly in the last step, the NN.
elif <code class="docutils literal notranslate"><span class="pre">version</span></code> == 5: then I, V, T and amb_T will be taken into account,
mixing models 2 and 4. Redundant.</p></li>
<li><p><strong>print_bool</strong> (<em>bool</em><em>, </em><em>default = False</em>) – Whether or not to print some information while the code runs.
Namely, if we want to print the battery’s name and the number of points.</p></li>
<li><p><strong>time_step</strong> (<em>int</em><em>, </em><em>optional</em>) – The desired time step for the resampling procedure.
If <code class="docutils literal notranslate"><span class="pre">None</span></code> is given, than a time step will be automatically generated
by the method <code class="docutils literal notranslate"><span class="pre">time_step_function</span></code>.</p></li>
<li><p><strong>threshold</strong> (<em>float</em><em>, </em><em>default = 0.1</em>) – The minimum capacity value to be considered as relevant [A.h].</p></li>
<li><p><strong>min_len</strong> (<em>int</em><em>, </em><em>default = 10</em>) – The minimum amount of points a charge cycle must have to be considered
as relevant.</p></li>
<li><p><strong>fixed_len</strong> (<em>int</em><em>, </em><em>optional</em>) – If different than <code class="docutils literal notranslate"><span class="pre">None</span></code> (default value), then the charge and discharge
curves will be limited to <code class="docutils literal notranslate"><span class="pre">fixed_len</span></code> points. This will override
<code class="docutils literal notranslate"><span class="pre">min_len</span></code>.</p></li>
<li><p><strong>norm_type</strong> (<em>{'zscore'</em><em>, </em><em>'minmax'}</em>) – A string indicating which kind of normalization to do.</p></li>
<li><p><strong>norm</strong> (<em>tuple</em><em>(</em><em>Tensor</em><em>, </em><em>Tensor</em><em>, </em><em>Tensor</em><em>, </em><em>Tensor</em><em>, </em><em>string</em><em>)</em><em>, </em><em>optional</em>) – A tuple containing all of the information necessary for normalization.
If entered as input, <code class="docutils literal notranslate"><span class="pre">norm_type</span></code> will be overridden by norm[4] and the
given information will be used for the normalization</p></li>
<li><p><strong>adimensionalize</strong> (<em>bool</em><em>, </em><em>default = True</em>) – Whether or not to make variables dimensionless before adding them to the
inputs and output lists.
The Capacity (output) is normalized by the nominal capacity
(<code class="docutils literal notranslate"><span class="pre">Q_nominal</span></code>);
The Current is normalized by the C rate (<code class="docutils literal notranslate"><span class="pre">C_rate</span></code>) -
which is the current necessary for charging the battery in one hour
(theoretically);
The Voltage is normalized by the nominal voltage (<code class="docutils literal notranslate"><span class="pre">V_nominal</span></code>),
the voltage at the plateau in the CV part of the charge curve.</p></li>
<li><p><strong>cycle_lim</strong> (<em>int</em><em>, </em><em>optional</em>) – The greatest cycle number to take into account for the dataset creation.
Default equals <code class="docutils literal notranslate"><span class="pre">1e6</span></code> meaning that no cycles will be ignored.</p></li>
</ul>
</dd>
</dl>
<dl class="py attribute">
<dt class="sig sig-object py" id="LSTM.Torch_Dataset_LSTM.dataset_name">
<span class="sig-name descname"><span class="pre">dataset_name</span></span><a class="headerlink" href="#LSTM.Torch_Dataset_LSTM.dataset_name" title="Permalink to this definition">¶</a></dt>
<dd><p>The name of the dataset (‘Dataset_Nasa’, for instance).</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>str</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="LSTM.Torch_Dataset_LSTM.batteries">
<span class="sig-name descname"><span class="pre">batteries</span></span><a class="headerlink" href="#LSTM.Torch_Dataset_LSTM.batteries" title="Permalink to this definition">¶</a></dt>
<dd><p>A list with the file name of each battery used.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>list[str]</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="LSTM.Torch_Dataset_LSTM.dataset_format">
<span class="sig-name descname"><span class="pre">dataset_format</span></span><a class="headerlink" href="#LSTM.Torch_Dataset_LSTM.dataset_format" title="Permalink to this definition">¶</a></dt>
<dd><p>A string indicating the type of data format used: ‘You et al. [56]’.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>str</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="LSTM.Torch_Dataset_LSTM.inputs">
<span class="sig-name descname"><span class="pre">inputs</span></span><a class="headerlink" href="#LSTM.Torch_Dataset_LSTM.inputs" title="Permalink to this definition">¶</a></dt>
<dd><p>A list with the input tensors for each cycle.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>list[Tensors]</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="LSTM.Torch_Dataset_LSTM.output">
<span class="sig-name descname"><span class="pre">output</span></span><a class="headerlink" href="#LSTM.Torch_Dataset_LSTM.output" title="Permalink to this definition">¶</a></dt>
<dd><p>A tensor with the output capacity tensors for each cycle.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>Tensor</p>
</dd>
</dl>
</dd></dl>

<dl class="field-list simple">
<dt class="field-odd">Raises</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>AssertionError</strong> – If the specified value of <code class="docutils literal notranslate"><span class="pre">delta</span></code> is &lt; 1.
    If no batteries are given.
    If the specified version is invalid.
    If <code class="docutils literal notranslate"><span class="pre">model_version</span></code> is 2 or 5 and <code class="docutils literal notranslate"><span class="pre">self.dataset_name</span></code> is
    <code class="docutils literal notranslate"><span class="pre">Clean_Coin_Battery</span></code>.</p></li>
<li><p><strong>ValueError</strong> – If the model_version is unknown.</p></li>
</ul>
</dd>
</dl>
<p class="rubric">Examples</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">from</span> <span class="nn">torch.utils.data</span> <span class="kn">import</span> <span class="n">Dataset</span>
<span class="gp">&gt;&gt;&gt; </span><span class="kn">from</span> <span class="nn">LSTM</span> <span class="kn">import</span> <span class="n">Torch_Dataset_LSTM</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">delta</span> <span class="o">=</span> <span class="mi">10</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">version</span> <span class="o">=</span> <span class="mi">2</span>
<span class="gp">&gt;&gt;&gt; </span><span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="s1">&#39;B0005.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
<span class="gp">... </span>    <span class="n">Battery</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
<span class="gp">...</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">train_dataset</span> <span class="o">=</span> <span class="n">Torch_Dataset_LSTM</span><span class="p">([</span><span class="n">Battery</span><span class="p">],</span> <span class="n">delta</span><span class="p">,</span> <span class="n">version</span><span class="p">,</span>
<span class="gp">... </span>                                   <span class="n">fixed_len</span><span class="o">=</span><span class="mi">150</span><span class="p">,</span> <span class="n">print_bool</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
<span class="go">B0005</span>
<span class="go">165</span>
</pre></div>
</div>
<dl class="py method">
<dt class="sig sig-object py" id="LSTM.Torch_Dataset_LSTM.time_step_function">
<span class="sig-name descname"><span class="pre">time_step_function</span></span><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#LSTM.Torch_Dataset_LSTM.time_step_function" title="Permalink to this definition">¶</a></dt>
<dd><p>Function for generating a time step when <code class="docutils literal notranslate"><span class="pre">None</span></code> is informed.</p>
<p>This function makes some extremely arbitrary choices, but that are based
on values of <code class="docutils literal notranslate"><span class="pre">time_step</span></code> that are known to work well with the
available datasets.</p>
<p>The function calculates the mean duration of the discharge cycles in the
given <code class="docutils literal notranslate"><span class="pre">Battery_list</span></code>, and divides it by <code class="docutils literal notranslate"><span class="pre">2*min_len</span></code> to get the
time_step. The factor 2 is there to ensure that most of the cycles will
have more than <code class="docutils literal notranslate"><span class="pre">fixed_len</span></code> points after resampling. It could be lower
or higher, but the results currently obtained for the available datasets
match well the manually tested ones.</p>
<dl class="field-list simple">
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p><strong>time_step</strong> – The time step [s].</p>
</dd>
<dt class="field-even">Return type</dt>
<dd class="field-even"><p>float</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="LSTM.Torch_Dataset_LSTM.report">
<span class="sig-name descname"><span class="pre">report</span></span><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#LSTM.Torch_Dataset_LSTM.report" title="Permalink to this definition">¶</a></dt>
<dd><p>Creates a little report with all of the information about the class.</p>
<dl class="field-list simple">
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p></p>
</dd>
<dt class="field-even">Return type</dt>
<dd class="field-even"><p>A string with the report information.</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="LSTM.Torch_Dataset_LSTM.dataset_info">
<span class="sig-name descname"><span class="pre">dataset_info</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">name</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#LSTM.Torch_Dataset_LSTM.dataset_info" title="Permalink to this definition">¶</a></dt>
<dd><p>Method for creating and information tuple that can be loaded for
creating a similar dataset in the future.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>name</strong> (<em>str</em>) – The name of the file where the tuple will be dumped.</p>
</dd>
</dl>
</dd></dl>

</dd></dl>

</div>


              </div>
              
              
              <div class='prev-next-bottom'>
                

              </div>
              
          </main>
          

      </div>
    </div>
  
  <script src="_static/js/index.1c5a1a01449ed65a7b51.js"></script>

  <footer class="footer mt-5 mt-md-0">
  <div class="container">
    
    <div class="footer-item">
      <p class="copyright">
    &copy; Copyright 2021, Antonio.<br/>
</p>
    </div>
    
    <div class="footer-item">
      <p class="sphinx-version">
Created using <a href="http://sphinx-doc.org/">Sphinx</a> 4.0.2.<br/>
</p>
    </div>
    
  </div>
</footer>
  </body>
</html>